;RPG-Tutorial4:  Maps Speichern und Laden

;Tutorial-4 beschftigt sich mit dem laden und speichern von sogenanten Maps.
;Maps sind die karten die vom computerspielen verwendet werden. Sie knnen
;zum Beispiel als dungeons, Stdte, Wlder, oder was einem noch so einfllt
;verwendet werden, ich pershnlich verwende sie fr all diese sachen und
;noch fr weitaus mehr. So, jetzt mal zur Theorie. Also eine map ist nur
;eine riesige anzahl von zahlen die dass programm mit nur 2
;Funktionen in eine array speichert. Wenn man dass geschaft hat muss man die
;zahlen, die ja jetzt in der array gespeichert sind nur noch sichtbar machen
;und dass war, wie ich zugeben muss nicht einfach. Am anfang habe ich nur tilemaps
;ohne scrolling, ohne mapeditor, ohne tilesets gemacht, also mit der Data-Methode
;die ich im ersten Kapittel, bereits erklhrt habe. Dass waren sehr finstere zeiten,
;da ich alle zahlen selber eintippen musste :( . Danach bin ich wie durch einen
;zufall auf den befehl Origin gestoen, der zwar ein unordentliches aber
;einfach zu verstehendes scrolling erzeugte, indem man die ursprungs-koordinaten
;der gemalten bilder neu anlegt. Aber dann fing der spa erst richtig an,
;ich hatte scrolling, also konnte ich auch grere maps laden, aber dass war unendlich
;mhsam. einmal habe ich sogar 3200 zahlen auf einmal in eine data-map geladen.
;Dass war ein hochgenu :) . Aber irgendwann wurde ich das eintippen der zahlen
;leid, also entwickelte ich den MapMaker2001v1, dies war ein kleiner, sehr 
;inkompatiebeler(was tilesets anging) mapeditor. Dessen besondere features
;das laden und speichern der Karten waren. Naja dass konnte zwar schon mein MapEditorV1,
;aber bei ihm musste man auch zahlen in eine data-map speichern. Und dass ist
;auch der springende punkt, dass eintippen der zahlen. Dieses Problem habe ich gelst
;indem ich jeden wert der map erst mal ein bild zugewiesen habe, danach
;habe ich mich an meinem alten kollisions-system orientiert(dass ihr
;aus meinen vorigen tuts kennen msstet), das die speilerposition
;der array-wert der map erkennt. Danach habe ich mir gedacht, wenn
;diese function den wert erkennt, dann kann man mit ihr sicher auch den wert verndern.
;Das prinzip ist eigentlich recht einfach, die karte wurde in der array map(x,y)
;gespeichert. Und der spieler in der array map(px,py). Da diese beiden die
;selbe array besetzen kann ich der map(px,py) auch einen beliebigen wert zuteilen
;da es ja die selbe karte ist, halt nur andere variablen, die zahler der karte mssen
;aber gleich sein.
;naja, ich nimm die spieler-positions veriablen und wandele den wert einfach in den
;um, den ich mchte: map(px,py) = Tile: Tile = Tile + 1 | durch diese 2 anweisungen
;wird in der wert der array um 1 erhht(+1). auch wenn man die map mit x und y malt
;wird sie trotzdem auch mit den variablen der spielfigur verndert(wie schon gesagt)
;die Karten speichere ich dann, indem ich die Function, die ich mit hilfe einiger freunde
;entwickent habe benutze, ich mache erst eine for-next-schleife und speichere danach den momentanen 
;wert der array mit WriteInt,WriteByte,WriteString oder WriteLine.
;Umgekehrt muss dass dann natrlich auch gehen also diemal mit Reabyte,Readint,Readline,Readstring.
;Ich werde euch jetz einen Mapeditor mit maussteuerung, Lade- Speicher- funktion
;und mit einem einfachen tileset, dass schon aus den vorigen teilen bekannt ist :)
;programmieren, dass wird wie ich hoffe nicht all zu schwer zu verstehen sein,
;weil ja schlielich in ein paar wochen auch die Multi-Layered-Maps dran sind
;und ich kann von mir selber behaupten, dass der M.E. dadurch nicht umbedingt leichter 
;zu verstehen sein wird. Ich, mchte euch diesen code so einfach wie mglich zu
;verstehen geben, wie ich kann. Aber ihr msst wie in allen vorigen Tuts
;auch hier sehr viel mitdenken, schlielich bin ich nich dafr euch die ganze arbeit
;weg zu nehmen, wo ihr denkt: "phh, das versteh ich schon". und am ende wo es richtig schwer wird
;habt ihr nix gelehrnt, das programmieren einer rpgs erfordert sehr viel geschich
;phantasie und intelligenz. Also, wenn ihr diesmal alles verstanden habt werdet
;ihr einen riesigen schritt nach vorne machen. Denn ihr knnt dann 
;einen Mapeditor mit Maussteuerung und Lade- Speicher Funktion herstellen. Und dass ist doch
;wirklich cool, oder?? Nagut ich glaube heute rede ich nen bischen zu viel runterrum,
;also hier ist der source!!!!! : 


;Kurz die funktions erklhrung

;----------------------------------------
;s-Taste     = speichern

;l-Taste     = laden

;l-Maustaste = Tile-setzen

;r-Maustaste = Tile wird wieder gra

;ESC-Taste   = Beenden

;1-6 Tasten  = Tiles wechseln
;----------------------------------------


;legt eine array an, die bei einer bildschirm auflsung
;von 1024*768 pixeln genau auf den monitor passt, also
;ohne berstehende unntze tiles, die man nicht sehen
;kann, weil kein scrolling eingebaut wurde.
Dim map(31,23)
;den Grafikmodus laden, wie vorher erwhnt 1024*768*16 
Graphics 1024,768,16,1
;Ld das tileset, dessen tiles 32*32 pixel gro sind
;das erste tile hat den wert 0 und es sind insgesamt 6 dieser
;mini bilder
Tileset = LoadAnimImage("tileset.bmp",32,32,0,6)
;ein mauszeiger, den ich mit Hypersnap aus einer curser-datei
;in das bitmap-format umgewandelt habe.
Maus = LoadImage("maus.bmp")
;hier werden alle variablen globalisier, die auch in den 
;functionen verwendet werden.
Global x,y,mx,my,mapx,mapy,tile = 1

;Startet die Hauptschleife 
Repeat
;Aktiviert den Backbuffer
SetBuffer BackBuffer()
;ESC-Taste zum beenden des programs
If KeyDown(1) Then End
;die array wird eingelesen und die map wird gemalt
For x = 0 To 31
For y = 0 To 23
DrawImage tileset,x*32,y*32,map(x,y)
Next
Next
;Die Tasten von 1 - 6 ich erklehre mal kurz die
;functione:

;Das zu malende tile hat die framezahl : 

;1-Taste = 1

;2-Taste = 2

;3-Taste = 3

;4-Taste = 4

;5-Taste = 5

;6-Taste = 0

If KeyDown(2) Then tile = 1
If KeyDown(3) Then tile = 2
If KeyDown(4) Then tile = 3
If KeyDown(5) Then tile = 4
If KeyDown(6) Then tile = 5
If KeyDown(7) Then tile = 0

;die veriablen mx und my werden den koordinaten der maus 
;zugewiesen.
mx = MouseX()
my = MouseY()
;wenn man die Linke maustaste drckt....
If MouseDown(1) Then
;wird die function scroll aufgerufen....
scroll()
;und dei aktuelelle positon des mauszeigers,
;die in der function scroll berechnet wird...
;also das tile wird einfach auf klick
;gesetzt, wobei das frame des tilesets
;die veriable tile angibt.
map(mapx,mapy) = tile
End If

;die selbe prozedur, nur dass diesmal die
;rechte maustaste gedrckt wird, und das
;tile nur in das frame mit dem wert 0 umgendert wird.
If MouseDown(2) Then
scroll()
map(mapx,mapy) = 0
End If


;S-Taste
;Die function zum speichern der map und der variabele tile
If KeyHit(31) Then save()
;L-Taste
;Funktion zum laden der map und der veriable tile
If KeyHit(38) Then load()
;malt den mauszeiger an den koordinaten mx und my, die
;vorher bereits den maus-ko. zugeteilt wurden
DrawImage maus,mx,my
;flippen und wieder zum anfang der schleife
Flip
Forever

;die function zum berechnen der position des tiles, das
;gesetzt werden soll
Function scroll()
;mapx wied berechnet, indem man die 
;aktuelle position der mauszeigers(mx,my)
;durch 32 teilt, dadurch kann mapx und mapy 
;nur in 32ger schritten gesetzt werden,
;also was dazwischen ist wird ignoriert
mapx = (mx)/32
mapy = (my)/32
End Function 

;funktion zum Speichern der map und der veriable tile
Function save() 
;dei datei wird erst geschrieben....
karte$ = WriteFile("map1.map")
;dann wird die array mal wieder fr die zeile 
;in der map(x,y) vorkommt eingalesen...
For x = 0 To 31
For y = 0 To 23
;speichert in der datei karte$ die veriable tile
WriteLine(karte$,tile)
;hier wird jetzt die array map(x,y) gespeichert
WriteInt(karte$,map(x,y))
Next
Next
;nicht vergessen umbedingt closefile eingeben
;sonst knnen fehler auftreten!!!
CloseFile(karte$)
End Function

;funktion zum Laden der map und der variable tile  
Function load()
;einlesen der datei
karte$ = ReadFile("map1.map")
;einlesen der array und der variable tile
For x = 0 To 31
For y = 0 To 23
tile = ReadLine(karte$)
map(x,y) = ReadInt(karte$)
Next
Next
;schlieen der datei
CloseFile(karte$)
End Function







 