;----------------------------------RPG-Tutorial5:  Pixel-by-Tile-Scrolling--------------------------
;Auf den wunsch vieler habe ich mich entschlossen meine Tutorial-Serie fortzusetzen
;Eigentlich hatte ich fr dieses tutorial Pixel-by-Pixel-Scrolling geplant, ich musste
;aber mit schande feststellen, das meine vorerst entwickelte pixel-by-pixel engine
;totaler schrott war, da man zwar sehr genaue kollision hatte, aber da ich die 
;array um das 256-fache vergrern musste und die tiles von der gre 32*32
;in 2*2 pixel umgerechnet werden mussten(dadurch konnte man die tiles nicht mehr manipulieren, 
;das heit keine tren/truhen ffnen und auch keine unterhaltung mit npcs)
;und aus diesen grnden habe ich mich entschlossen mit euch pixel-by-tile-scrolling
;zu besprechen. es ist ein wenig anders aufgebaut als p*p, da man zwar ein sanftes scrolling hat
;die kollision aber tile*tile verluft. Folgende spiele benutzen pixel-by-tile:
;Pokenmon(gelb,rot,blau,gold,silber), Zelda(wenn man es sich genauer anschaut),
;FinalFantasy bis teil 6. Dieses scrolling ist ab sofort auch meine lieblings methode, da sie
;einfach und effizient ist, und auerdem wozu braucht man schon dieses pixel*pixel zeugs,
;es ist viel langsamer, schwieriger und die kollision sieht sehr unrealistisch aus,
;ein echter mensch kann ja schlielich an einem schrank vorbeigehen, auch wenn seine
;schulter den schrank zu 2mm berhrt. Ohh, und fast htte ich es vergessen. einen schnen
;dank noch an DivineDominion, der mir in einigen punkten geholfen hat :) 
;also testet ein paar mal rum um zu sehen, wie pixel*tile-scrolling functioniert
;ansonsten steht wie immer alles, ber die funktionsweise in code.
;---------------------------------------------------------------------------------------------------
;graficmodus
Graphics 640,480,16,1
;setbuffer initialisieren
SetBuffer BackBuffer()
;die bentigten variablen
Global ppx = 10*32 ;X-Position des Charackters
Global ppy = 7*32  ;Y-Position des Charackters
Global py = 7      ;Kollisions X-Position des Charackters
Global px = 10     ;Kollisions Y-Position des Charackters
Global scrolly     ;Die Variable fr die ScrollY-Position
Global scrollx     ;Die Variable fr die ScrollX-Position
;die bentigten bilder
Global char    = LoadImage("char.bmp")
Global Tileset = LoadAnimImage("tileset.bmp",32,32,0,6)
;die map-array 
Dim map(20,20)
;die Karte
Data 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,4
Data 4,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,3,3,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,3,3,0,0,0,0,0,0,0,0,3,3,0,0,0,0,4
Data 4,0,0,0,3,3,0,0,0,0,0,0,0,0,3,3,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4
Data 4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4
;einlesen und die zahlen der Tiles in der array speichern
For y = 0 To 20
For x = 0 To 20
;einlesen der werte aus der data map in die array
Read map(x,y)
Next
Next
;start der hauptschleife
Repeat
;unntze graficreste lschen
Cls
;esc-taste zum beenden abfragen
If KeyDown(1) Then Exit
;die 20*20 tiles groe map laden
For x = 0 To 20
For y = 0 To 20
;malt die karte an der positon x*32,y*32 und man kann die variablen scrollx und scrolly 
;von auen manipulieren, um so scrolling zu erzeugen
DrawBlock tileset,x*32-scrollx,y*32-scrolly,map(x,y)
Next
Next
;malt den charackter den du steuerst
DrawImage char,ppx-scrollx,ppy-scrolly

Text 0,0,py
Text 0,20,px
;_____________________Bewegungsrutinen fr die einzelnen pfeil-tasten________________________________

;diese rutinen funcktionieren ganz einfach, solange aa grer 0 ist bleiben sie 
;acktiv und es wird gescrollt
;pfeilrunter-taste
If move = 1 Then 
;wenn der wert aa grer 0 ist wird fortgesetzt
If aa > 0
;solange der wert aa grer 0 ist wird um 2 pixel weiter gescrollt 
scrolly = scrolly + 2
;die sichtbare figur wird bewegt
ppy = ppy + 2
;die variable xo wird solange aa > 0 ist erhht
xo = xo + 1
;wenn xo den wert 16 erreicht hat wird aa wieder auf 0 gesetzt und der kollisionsparameter
;py wird verndert, danach wird xo wieder auf 0 gesetzt
If xo = 16 Then aa = 0:py = py + 1:xo = 0
End If
End If

;pfeilhoch-taste
If move = 2 Then 
If aa > 0
scrolly = scrolly - 2
ppy = ppy - 2
xo = xo + 1
If xo = 16 Then aa = 0:py = py - 1:xo = 0
End If
End If
;pfeillinks-taste
If move = 3 Then 
If aa > 0
scrollx = scrollx - 2
ppx = ppx - 2
xo = xo + 1
If xo = 16 Then aa = 0:px = px - 1:xo = 0
End If
End If
;pfeilrechts-taste
If move = 4 Then 
If aa > 0
scrollx = scrollx + 2
ppx = ppx + 2
xo = xo + 1
If xo = 16 Then aa = 0:px = px + 1:xo = 0
End If
End If

;rechs-taste
If KeyDown(205) Then
;kollision checken, wie ihr es schon kennt
If map(px+1,py) < 1 Then 
;der nchste tastatur-eingabe-impuls wird mglich sobald aa weniger als 1 wert ist
;das heit in der zeit wo keine tastatur-eingabe erfolgen kann wird zur zeit gescrollt
If aa < 1 Then
;die scrollrutine move = 4 wird aufgerufen
move = 4
;aa nimmt den wert 1 an dadurch kann man erst wieder auf eine taste drcken, wenn
;aa < 1 wird
aa = 1
End If
End If
End If

;lings-taste
If KeyDown(203) Then 
;kollision checken, wie ihr es schon kennt
If map(px-1,py) < 1 Then 
If aa < 1 Then
move = 3
aa = 1
End If
End If
End If

;oben-taste
If KeyDown(200) Then
;kollision checken, wie ihr es schon kennt
If map(px,py-1) < 1 Then
If aa < 1 Then
move = 2
aa = 1
End If
End If
End If

;unten-taste
If KeyDown(208) Then
;kollision checken, wie ihr es schon kennt
If map(px,py+1) < 1 Then  
If aa < 1 Then
move = 1
aa = 1
End If
End If
End If
;flippen und zurck zum anfand der hauptschleife
Flip
Forever
;images wieder freigeben
FreeImage tileset
FreeImage char
;beenden
End 

;bei fragen und beschwerden meldet ihr euch bitte an
;BlitzBasicUser@aol.com
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;